/*************************************************************************/
//
// [JPL DE V]œVvZ  jpl_eph_6.0.c   2022/10/03
//
//                            takesako@mrj.biglobe.ne.jp
//
//@̃vOdr. Piotr A. DybczynskiJPLBIN(v.1.6)gݍ
//  ver.5̉Ńo[WłB܂f^T̒lC܂B
//
//@KvJPL̃f[^t@C͈ȉ_E[hĂB
//  https://ssd.jpl.nasa.gov/ftp/eph/planets/Linux/
//
//@܂ADE431/441ɂẮAAD10000Nȏ̒lvZꍇA
//@32bitn}Vł̓AhXẘ֌WŃANZXG[͌듮삵܂B
//@DE431t@C\[X"DE431_divide_1.0.zip"gt@C
//@2ĎgpB
//@(t̓߂őz0x߂ɂȂƁAsvZlłB)
//
//@t@C̃ANZXꏊ͂ꂼ̊ɉďĈƁB
//
/*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "astro.h"


// This header was modified from TESTEPH program JPLBIN.h(v.1.6) 

/***************************************************************************
*******                  JPLBIN.H   v.1.6                          *********
****************************************************************************
**  This header file is used by TESTEPH program.                          **
**  It is NECESSARY TO ADJUST IT MANUALLY for different ephemerides.      **
****************************************************************************
**  Written: May 28, 1997 by PAD  **  Last modified: April 18,2021 by PAD **
****************************************************************************
**  PAD: dr. Piotr A. Dybczynski,          e-mail: dybol@amu.edu.pl       **
** Astronomical Observatory Institute, A.Mickiewicz Univ., Poznan, Poland **
**      https://apollo.astro.amu.edu.pl/PAD/pmwiki.php?n=Dybol.JPLEph     **
***************************************************************************/

#define DKSIZE 2036 //ftHg̃t@CTCYݒ
#define TRUE 1
#define FALSE 0

/* the following two definitions adapt the software for larger number of constants (1000)
(eg. for DE430 and DE431 and later ones) */

#define NMAX 1000
#define OLDMAX 400

#pragma pack(push, 1) 

struct   rec1{
         char ttl[3][84];
         char cnam[OLDMAX][6];
         double ss[3];
         int ncon;
         double au;
         double emrat;
         int ipt[12][3];
         int numde;
         int lpt[3];
         int rpt[3];
         int tpt[3];
         char cnam2[(NMAX-OLDMAX)][6];
       };

struct {
         struct rec1 r1;
         char spare[4*DKSIZE-sizeof(struct rec1)];
       } R1;

 struct  rec2{
         double cval[DKSIZE];
       } ;

 struct {
         struct rec2 r2;
       } R2;


FILE *fp_Bin,*fp_Bin1;

int KSIZE;
int KM=0,BARY=0;
double PVSUN[6];


/*========================================================================+
|                               INITIAL                                   |
+=========================================================================+
| DESCRIPTION:                                                            |
| INITIALIZE THE CONSTANTS FROM THE JPL BINARY FILE.                      |
+========================================================================*/

FILE *INITIAL(int DE)
{

		char *Name;
		char nams[NMAX][6];
		double ss[3], vals[NMAX];
		int i,  nvs;

// ePCɂăt@C̎QƏꏊC邱ƁB
// Please change the directory based on you PC HDD. 

				KSIZE=2036;//DE200/DE406ȊO

if (DE==403){
				Name="e:\\data\\de403\\lnxp1600p2200.403";
				}
		else if (DE==405){
				Name="e:\\data\\de405\\lnxp1600p2200.405";
				}
		else if (DE==421){
				Name="e:\\data\\de421\\lnxp1900p2053.421";
				}
		else if (DE==422){
				Name="e:\\data\\de422\\lnxm3000p3000.422";
				}
		else if (DE==430){
				Name="e:\\data\\de430\\linux_p1550p2650.430";
				}
		else if (DE==440){
				Name="e:\\data\\de440\\linux_p1550p2650.440";
				}
		else if (DE==200){
				Name="e:\\data\\de200\\lnxm1600p2170.200";
				KSIZE=1652;// KSIZE2036ł͖̂ŗvݒB
				}
		else if (DE==406){
				Name="e:\\data\\de406\\lnxm3000p3000.406";
				KSIZE=1456;// KSIZE2036ł͖̂ŗvݒB
				}

		else if (DE==431){
				Name="e:\\data\\de431\\lnxm13000p17000.431";// t@CȂꍇBꍇ̓RgAEg邱ƁB
				// ȉ5s̓t@CꍇBȂꍇ̓RgAEg邱ƁB
//				Name="e:\\data\\de431\\lnxm13000p10000.431";// t@CꍇB
//				if((fp_Bin1 = fopen("e:\\data\\de431\\lnxp10000p17000.431","rb")) == NULL)
//				{ printf("Cannot open lnxp10000p17000.431 file.\n");
//						exit(1);
//				};
		}

		else if (DE==441){
				Name="e:\\data\\de441\\linux_m13000p17000.441";// t@CȂꍇBꍇ̓RgAEg邱ƁB
				// ȉ5s̓t@CꍇBȂꍇ̓RgAEg邱ƁB
//				Name="e:\\data\\de441\\lnxm13000p10000.441";
//				if((fp_Bin1 = fopen("e:\\data\\de441\\lnxp10000p17000.441","rb")) == NULL)
//				{ printf("Cannot open lnxp10000p17000.441 file.\n");
//						exit(1);
//				};
		}

/**************************************************************/


		/* READ THE SIZE AND NUMBER OF MAIN EPHEMERIS: */
		if((fp_Bin = fopen(Name,"rb")) == NULL)
				{ printf(/*stderr,*/ "Cannot open %s file.\n",Name); // 2015/03/16
						exit(1);
				};

/****** Print the ephemeris constants. **************************************/

// DE***t@C̃wb_[̓ǂݍ݁B

  constan(nams,vals,ss,&nvs);   /* we change the name of this routine
                                   because const is the reserved token in C */

//  p[^̕\KvȏꍇRg͂B
//  printf("%14.2f  %14.2f  %14.2f\n",ss[0],ss[1],ss[2]);
//  for(i=0;i<nvs;++i)
//  printf("%.6s  %24.16E\n",nams[i],vals[i]);

		return(fp_Bin);
}

/************  JPLBIN.H   v.1.6 (Last modified: April 18,2021 by PAD)  *************/

/*****************************************************************************
**                         pleph(et,ntar,ncent,rrd)                         **
******************************************************************************
**                                                                          **
**    This subroutine reads the jpl planetary ephemeris                     **
**    and gives the position and velocity of the point 'ntarg'              **
**    with respect to 'ncent'.                                              **
**                                                                          **
**    Calling sequence parameters:                                          **
**                                                                          **
**      et = (double) julian ephemeris date at which interpolation          **
**           is wanted.                                                     **
**                                                                          **
**    ntarg = integer number of 'target' point.                             **
**                                                                          **
**    ncent = integer number of center point.                               **
**                                                                          **
**    The numbering convention for 'ntarg' and 'ncent' is:                  **
**                                                                          **
**            1 = mercury           8 = neptune                             **
**            2 = venus             9 = pluto                               **
**            3 = earth            10 = moon                                **
**            4 = mars             11 = sun                                 **
**            5 = jupiter          12 = solar-system barycenter             **
**            6 = saturn           13 = earth-moon barycenter               **
**            7 = uranus           14 = nutations (longitude and obliq)     **
**                                 15 = librations, if on eph. file         **
**                                                                          **
**            (If nutations are wanted, set ntarg = 14.                     **
**             For librations, set ntarg = 15. set ncent= 0)                **
**                                                                          **
**     rrd = output 6-element, double array of position and velocity        **
**           of point 'ntarg' relative to 'ncent'. The units are au and     **
**           au/day. For librations the units are radians and radians       **
**           per day. In the case of nutations the first four words of      **
**           rrd will be set to nutations and rates, having units of        **
**           radians and radians/day.                                       **
**                                                                          **
**           The option is available to have the units in km and km/sec.    **
**           for this, set km=TRUE at the beginning of the program.         **
*****************************************************************************/
void pleph(double et,int ntarg,int ncent,double rrd[] )
{
  double et2[2],pv[13][6];/* pv is the position/velocity array
                             NUMBERED FROM ZERO: 0=Mercury,1=Venus,...
                             8=Pluto,9=Moon,10=Sun,11=SSBary,12=EMBary
                             First 10 elements (0-9) are affected by state(),
                             all are adjusted here.                         */


  int bsave,i,k;
  int list[12];          /* list is a vector denoting, for which "body"
                            ephemeris values should be calculated by state():
                            0=Mercury,1=Venus,2=EMBary,...,8=Pluto,
                            9=geocentric Moon, 10=nutations in long. & obliq.
                            11= lunar librations  */

/*  initialize et2 for 'state' and set up component count   */

  et2[0]=et;
  et2[1]=0.0;

  for(i=0;i<6;++i) rrd[i]=0.0;

  if(ntarg == ncent) return;

  for(i=0;i<12;++i) list[i]=0;

/*   check for nutation call    */

  if(ntarg == 14)
    {
      if(R1.r1.ipt[11][1] > 0) /* there is nutation on ephemeris */
        {
          list[10]=2;
          state(et2,list,pv,rrd);
        }
      else puts("***** no nutations on the ephemeris file  ******\n");
      return;
    }

/*  check for librations   */

  if(ntarg == 15)
    {
      if(R1.r1.lpt[1] > 0) /* there are librations on ephemeris file */
        {
          list[11]=2;
          state(et2,list,pv,rrd);
          for(i=0;i<6;++i)  rrd[i]=pv[10][i]; /* librations */
        }
      else puts("*****  no librations on the ephemeris file  *****\n");
      return;
    }

/*  force barycentric output by 'state'     */

  bsave=BARY;
  BARY= TRUE;

/*  set up proper entries in 'list' array for state call     */

  for(i=0;i<2;++i) /* list[] IS NUMBERED FROM ZERO ! */
     {
      k=ntarg-1;
      if(i == 1) k=ncent-1;   /* same for ntarg & ncent */
      if(k <= 9) list[k]=2;   /* Major planets */
      if(k == 9) list[2]=2;   /* for moon state earth state is necessary*/
      if(k == 2) list[9]=2;   /* for earth state moon state is necessary*/
      if(k == 12) list[2]=2;  /* EMBary state additionally */
     }

/*   make call to state   */

  state(et2,list,pv,rrd);
  /* Solar System barycentric Sun state goes to pv[10][] */
  if(ntarg == 11 || ncent == 11) for(i=0;i<6;++i) pv[10][i]=PVSUN[i];

  /* Solar System Barycenter coordinates & velocities equal to zero */
  if(ntarg == 12 || ncent == 12) for(i=0;i<6;++i) pv[11][i]=0.0;

  /* Solar System barycentric EMBary state:  */
  if(ntarg == 13 || ncent == 13) for(i=0;i<6;++i) pv[12][i]=pv[2][i];

  /* if moon from earth or earth from moon ..... */
  if( (ntarg*ncent) == 30 && (ntarg+ncent) == 13)
      for(i=0;i<6;++i) pv[2][i]=0.0;
  else
    {
       if(list[2] == 2) /* calculate earth state from EMBary */
          for(i=0;i<6;++i) pv[2][i] -= pv[9][i]/(1.0+R1.r1.emrat);

       if(list[9] == 2) /* calculate Solar System barycentric moon state */
          for(i=0;i<6;++i) pv[9][i] += pv[2][i];
    }

  for(i=0;i<6;++i)  rrd[i]=pv[ntarg-1][i]-pv[ncent-1][i];
  BARY=bsave;

  return;
}
/*****************************************************************************
**                     interp(buf,t,ncf,ncm,na,ifl,pv)                      **
******************************************************************************
**                                                                          **
**    this subroutine differentiates and interpolates a                     **
**    set of chebyshev coefficients to give position and velocity           **
**                                                                          **
**    calling sequence parameters:                                          **
**                                                                          **
**      input:                                                              **
**                                                                          **
**        buf   1st location of array of d.p. chebyshev coefficients        **
**              of position                                                 **
**                                                                          **
**          t   t[0] is double fractional time in interval covered by       **
**              coefficients at which interpolation is wanted               **
**              (0 <= t[0] <= 1).  t[1] is dp length of whole               **
**              interval in input time units.                               **
**                                                                          **
**        ncf   # of coefficients per component                             **
**                                                                          **
**        ncm   # of components per set of coefficients                     **
**                                                                          **
**         na   # of sets of coefficients in full array                     **
**              (i.e., # of sub-intervals in full interval)                 **
**                                                                          **
**         ifl  integer flag: =1 for positions only                         **
**                            =2 for pos and vel                            **
**                                                                          **
**                                                                          **
**      output:                                                             **
**                                                                          **
**        pv   interpolated quantities requested.  dimension                **
**              expected is pv(ncm,ifl), dp.                                **
**                                                                          **
*****************************************************************************/
void interp(double coef[],double t[2],int ncf,int ncm,int na,int ifl,
            double posvel[6])
{
  static double pc[18],vc[18];
  static int np=2, nv=3, first=1;
  static double twot=0.0;
  double dna,dt1,temp,tc,vfac,temp1;
  int l,i,j;

  if(first){           /* initialize static vectors when called first time */
             pc[0]=1.0;
             pc[1]=0.0;
             vc[1]=1.0;
             first=0;
           }

/*  entry point. get correct sub-interval number for this set
    of coefficients and then get normalized chebyshev time
    within that subinterval.                                             */

  dna=(double)na;
  modf(t[0],&dt1);
  temp=dna*t[0];
  l=(int)(temp-dt1);

/*  tc is the normalized chebyshev time (-1 <= tc <= 1)    */

  tc=2.0*(modf(temp,&temp1)+dt1)-1.0;

/*  check to see whether chebyshev time has changed,
    and compute new polynomial values if it has.
    (the element pc[1] is the value of t1[tc] and hence
    contains the value of tc on the previous call.)     */

  if(tc != pc[1])
    {
      np=2;
      nv=3;
      pc[1]=tc;
      twot=tc+tc;
    }

/*  be sure that at least 'ncf' polynomials have been evaluated
    and are stored in the array 'pc'.    */

  if(np < ncf)
    {
      for(i=np;i<ncf;++i)  pc[i]=twot*pc[i-1]-pc[i-2];
      np=ncf;
    }

/*  interpolate to get position for each component  */

  for(i=0;i<ncm;++i) /* ncm is a number of coordinates */
     {
       posvel[i]=0.0;
       for(j=ncf-1;j>=0;--j)
          posvel[i]=posvel[i]+pc[j]*coef[j+i*ncf+l*ncf*ncm];
     }

      if(ifl <= 1) return;


/*  if velocity interpolation is wanted, be sure enough
    derivative polynomials have been generated and stored.    */

  vfac=(dna+dna)/t[1];
  vc[2]=twot+twot;
  if(nv < ncf)
    {
      for(i=nv;i<ncf;++i) vc[i]=twot*vc[i-1]+pc[i-1]+pc[i-1]-vc[i-2];
      nv=ncf;
    }

/*  interpolate to get velocity for each component    */

   for(i=0;i<ncm;++i)
      {
        posvel[i+ncm]=0.0;
        for(j=ncf-1;j>0;--j)
           posvel[i+ncm]=posvel[i+ncm]+vc[j]*coef[j+i*ncf+l*ncf*ncm];
        posvel[i+ncm]=posvel[i+ncm]*vfac;
      }
   return;
}

/****************************************************************************
****                       split(tt,fr)                                  ****
*****************************************************************************
****  this subroutine breaks a d.p. number into a d.p. integer           ****
****  and a d.p. fractional part.                                        ****
****                                                                     ****
****  calling sequence parameters:                                       ****
****                                                                     ****
****    tt = d.p. input number                                           ****
****                                                                     ****
****    fr = d.p. 2-word output array.                                   ****
****         fr(1) contains integer part                                 ****
****         fr(2) contains fractional part                              ****
****                                                                     ****
****         for negative input numbers, fr(1) contains the next         ****
****         more negative integer; fr(2) contains a positive fraction.  ****
****************************************************************************/
void split(double tt, double fr[2])
{
/*  main entry -- get integer and fractional parts  */

      fr[1]=modf(tt,&fr[0]);

      if(tt >= 0.0 || fr[1] == 0.0) return;

/*  make adjustments for negative input number   */

      fr[0]=fr[0]-1.0;
      fr[1]=fr[1]+1.0;

      return;
}

/*****************************************************************************
**                        state(et2,list,pv,nut)                            **
******************************************************************************
** This subroutine reads and interpolates the jpl planetary ephemeris file  **
**                                                                          **
**    Calling sequence parameters:                                          **
**                                                                          **
**    Input:                                                                **
**                                                                          **
**        et2[] double, 2-element JED epoch at which interpolation          **
**              is wanted.  Any combination of et2[0]+et2[1] which falls    **
**              within the time span on the file is a permissible epoch.    **
**                                                                          **
**               a. for ease in programming, the user may put the           **
**                  entire epoch in et2[0] and set et2[1]=0.0               **
**                                                                          **
**               b. for maximum interpolation accuracy, set et2[0] =        **
**                  the most recent midnight at or before interpolation     **
**                  epoch and set et2[1] = fractional part of a day         **
**                  elapsed between et2[0] and epoch.                       **
**                                                                          **
**               c. as an alternative, it may prove convenient to set       **
**                  et2[0] = some fixed epoch, such as start of integration,**
**                  and et2[1] = elapsed interval between then and epoch.   **
**                                                                          **
**       list   12-element integer array specifying what interpolation      **
**              is wanted for each of the "bodies" on the file.             **
**                                                                          **
**                        list[i]=0, no interpolation for body i            **
**                               =1, position only                          **
**                               =2, position and velocity                  **
**                                                                          **
**              the designation of the astronomical bodies by i is:         **
**                                                                          **
**                        i = 0: mercury                                    **
**                          = 1: venus                                      **
**                          = 2: earth-moon barycenter                      **
**                          = 3: mars                                       **
**                          = 4: jupiter                                    **
**                          = 5: saturn                                     **
**                          = 6: uranus                                     **
**                          = 7: neptune                                    **
**                          = 8: pluto                                      **
**                          = 9: geocentric moon                            **
**                          =10: nutations in longitude and obliquity       **
**                          =11: lunar librations (if on file)              **
**                                                                          **
**                                                                          **
**    output:                                                               **
**                                                                          **
**    pv[][6]   double array that will contain requested interpolated       **
**              quantities.  The body specified by list[i] will have its    **
**              state in the array starting at pv[i][0]  (on any given      **
**              call, only those words in 'pv' which are affected by the    **
**              first 10 'list' entries (and by list(11) if librations are  **
**              on the file) are set.  The rest of the 'pv' array           **
**              is untouched.)  The order of components in pv[][] is:       **
**              pv[][0]=x,....pv[][5]=dz.                                   **
**                                                                          **
**              All output vectors are referenced to the earth mean         **
**              equator and equinox of epoch. The moon state is always      **
**              geocentric; the other nine states are either heliocentric   **
**              or solar-system barycentric, depending on the setting of    **
**              global variables (see below).                               **
**                                                                          **
**              Lunar librations, if on file, are put into pv[10][k] if     **
**              list[11] is 1 or 2.                                         **
**                                                                          **
**        nut   dp 4-word array that will contain nutations and rates,      **
**              depending on the setting of list[10].  the order of         **
**              quantities in nut is:                                       **
**                                                                          **
**                       d psi  (nutation in longitude)                     **
**                       d epsilon (nutation in obliquity)                  **
**                       d psi dot                                          **
**                       d epsilon dot                                      **
**                                                                          **
**    Global variables:                                                     **
**                                                                          **
**         KM   logical flag defining physical units of the output          **
**              states. KM = TRUE, km and km/sec                            **
**                         = FALSE, au and au/day                           **
**              default value = FALSE.  (Note that KM determines time unit  **
**              for nutations and librations. Angle unit is always radians.)**
**                                                                          **
**       BARY   logical flag defining output center.                        **
**              only the 9 planets (entries 0-8) are affected.              **
**                       BARY = TRUE =\ center is solar-system barycenter   **
**                            = FALSE =\ center is sun                      **
**              default value = FALSE                                       **
**                                                                          **
**      PVSUN   double, 6-element array containing                          **
**              the barycentric position and velocity of the sun.           **
**                                                                          **
*****************************************************************************/
void state(double et2[2],int list[12],double pv[][6],double nut[4])
{
  int i,j;
  static int ipt[13][3], first=TRUE;
                  /* local copy of R1.r1.ipt[] is extended for R1.r1.lpt[[] */
  int nr;
  static int nrl=0;
  double pjd[4];
  static double buf[DKSIZE/2];
  double s,t[2],aufac;
  double pefau[6];

  if(first)
    {
      first=FALSE;
      for(i=0;i<3;++i)
         {
           for(j=0;j<12;++j) ipt[j][i]=(int)R1.r1.ipt[j][i];
           ipt[12][i] = (int)R1.r1.lpt[i];
         }
   }

/*  ********** main entry point **********  */

  s=et2[0] - 0.5;
  split(s,&pjd[0]);
  split(et2[1],&pjd[2]);
  pjd[0]=pjd[0]+pjd[2]+0.5;
  pjd[1]=pjd[1]+pjd[3];
  split(pjd[1],&pjd[2]);
  pjd[0]=pjd[0]+pjd[2];

/* here pjd[0] contains last midnight before epoch desired (in JED: *.5)
   and pjd[3] contains the remaining, fractional part of the epoch         */


  if(et2[0]<5373872.50) // Before 10001/ 1/23 AM0.00(TT)
  {


/*   error return for epoch out of range  */

  if( (pjd[0]+pjd[3]) < R1.r1.ss[0] || (pjd[0]+pjd[3]) > R1.r1.ss[1] )
    {
      puts("Requested JED not within ephemeris limits.\n");
      return;
    }

/*   calculate record # and relative time in interval   */

      nr=(int)((pjd[0]-R1.r1.ss[0])/R1.r1.ss[2])+2;
      /* add 2 to adjust for the first two records containing header data */
      if(pjd[0] == R1.r1.ss[1]) nr=nr-1;
      t[0]=( pjd[0]-( (1.0*nr-2.0)*R1.r1.ss[2]+R1.r1.ss[0] ) +
           pjd[3] )/R1.r1.ss[2];

/*   read correct record if not in core (static vector buf[])   */

      if(nr != nrl)
        {
		nrl=nr;
		if(KSIZE==2036)
		{
		  fseek(fp_Bin,nr*4*KSIZE,SEEK_SET);
		  fread(buf,sizeof(buf),1,fp_Bin);
		}
		else // In case of DE200 and DE406 
		{
		  fseek(fp_Bin,nr*4*KSIZE,SEEK_SET);
		  for(i=0;i<KSIZE/2;i++)fread(&buf[i],sizeof(double),1,fp_Bin);
		}
	  } 
  }

  else  //if(et2[0]<5373872.50) // After 10001/ 1/23 AM0.00(TT)
  {


/*   error return for epoch out of range  */

  if( KSIZE != 2036 ) // In case of DE200 or DE406 
    {
      puts("Requested JED is not supported with this DE file\n");
      return;
    }

  if( (pjd[0]+pjd[3]) <  5373872.50 || (pjd[0]+pjd[3]) > 7930192.50 ) // 10001/ 1/23 to 17000/ 1/11
    {
      puts("Requested JED not within ephemeris limits.\n");
      return;
    }

/*   calculate record # and relative time in interval   */

      nr=(int)((pjd[0]-5373392.50)/R1.r1.ss[2])+2;
      /* add 2 to adjust for the first two records containing header data */
      if(pjd[0] == R1.r1.ss[1]) nr=nr-1;
      t[0]=( pjd[0]-( (1.0*nr-2.0)*R1.r1.ss[2]+5373392.50) +
           pjd[3] )/R1.r1.ss[2];


/*   read correct record if not in core (static vector buf[])   */

      if(nr != nrl)
        {
          nrl=nr;
          fseek(fp_Bin1,nr*4*KSIZE,SEEK_SET);
          fread(buf,sizeof(buf),1,fp_Bin1);
        }
  }

      if(KM)
        {
          t[1]=R1.r1.ss[2]*86400.0;
          aufac=1.0;
        }
      else
        {
          t[1]=R1.r1.ss[2];
          aufac=1.0/R1.r1.au;
        }

/*  every time interpolate Solar System barycentric sun state   */

    interp(&buf[ipt[10][0]-1],t,ipt[10][1],3,ipt[10][2],2,pefau);

      for(i=0;i<6;++i)  PVSUN[i]=pefau[i]*aufac;

/*  check and interpolate whichever bodies are requested   */

      for(i=0;i<10;++i)
         {
           if(list[i] == 0) continue;

           interp(&buf[ipt[i][0]-1],t,ipt[i][1],3,ipt[i][2],list[i],pefau);

           for(j=0;j<6;++j)
              {
                if(i < 9 && !BARY)   pv[i][j]=pefau[j]*aufac-PVSUN[j];
                else                 pv[i][j]=pefau[j]*aufac;
              }
         }

/*  do nutations if requested (and if on file)    */

      if(list[10] > 0 && ipt[11][1] > 0)
         interp(&buf[ipt[11][0]-1],t,ipt[11][1],2,ipt[11][2],list[10],nut);

/*  get librations if requested (and if on file)    */

      if(list[11] > 0 && ipt[12][1] > 0)
        {
          interp(&buf[ipt[12][0]-1],t,ipt[12][1],3,ipt[12][2],list[11],pefau);
          for(j=0;j<6;++j) pv[10][j]=pefau[j];
        }
  return;
}
/****************************************************************************
**                        constan(nam,val,sss,n)                           **
*****************************************************************************
**                                                                         **
**    this function obtains the constants from the ephemeris file          **
**    calling sequence parameters (all output):                            **
**      char nam[][6] = array of constant names (max 6 characters each)    **
**      double val[] = array of values of constants                        **
**      double sss[3] = JED start, JED stop, step of ephemeris             **
**      int n = number of entries in 'nam' and 'val' arrays                **
** Note: we changed name of this routine because const is a reserved word  **
**       in the C language.                                                **
*****************************************************************************
**    external variables:                                                  **
**         struct R1 and R2 (first two records of ephemeris)               **
**         defined in file:     jplbin.h                                   **
**         fp_Bin = ephemeris binary file pointer (obtained from fopen() )     **
****************************************************************************/
void constan(char nam[][6], double val[], double sss[], int *n)
{
  int i,j;

  fread(&R1,sizeof(R1),1,fp_Bin);
  *n =(int)R1.r1.ncon;

  if(KSIZE==2036){
  fread(&R2,sizeof(R2),1,fp_Bin);
  }
  else {
   fseek(fp_Bin,1*KSIZE*4,SEEK_SET);
   for(i=0;i<*n;i++)fread(&R2.r2.cval[i],sizeof(double),1,fp_Bin);
  }

  for(i=0;i<3;++i) sss[i]=R1.r1.ss[i];

  for(i=0;i<OLDMAX;++i)
      for(j=0;j<6;++j) nam[i][j] = R1.r1.cnam[i][j];

  if(*n > OLDMAX) 
      for(i=OLDMAX;i<*n;++i)
          for(j=0;j<6;++j) nam[i][j] = R1.r1.cnam2[i-OLDMAX-4][j]; // Added "-4" 2022/09/26 

  for(i=0;i<*n;++i)  val[i] = R2.r2.cval[i];

  return;
}
/*******************************/

//@ȉ̌vZver.5ƓB(C)

/*========================================================================+
|                               Ephemerides                               |
+=========================================================================*/

void Ephemerides(FILE *fp_Bin,int DE, double jd,int Planet,Position *Eph)
// jd͗͊w(TT:Terrestrial Time )

{

	
/*	 The detailed calculation method is described in the
	   "The Astromical Almanac"
	   Page B36 to B39 in case of 1999 version */

// The program was revised based on Astromical Almanac 2014
// B68-B70, B52 and B56 at step 5 &7.    2015/03/16

	
		/* VARIABLES FOR JPL COMPUTATION:*/

		/* VARIABLE DECLARATION: */
		int nctr,ntarg,n;
		double r[6],et,et0;
		double Tau;
		double sd;
		double Obl,dE0,dF0;//2015/03/15
		double ex,ey,ez,rr,sx,sy,sz,srr,px,py,pz,dd,pa,B,t,inc,omg; // 2016/09/12

	Matrix_1 Eb,Ed,E,Sb,Qb,P,Q,p,q,e,p00,p01,p02,p1,p2,p3,V,p20,p21;
	Matrix_3 Pr,Nu3;
	double   S_Eb,S_E,S_Sb,S_Qb,S_Q,S_P,S_P0,S_p,S_q,S_e,S_pq,S_ep,S_qe,S_V,S_p1V,S_p3,Beta;

// **********************
//			step. 1
// **********************
						et0=jd;
						nctr  = 12;
						/* Where does the ephemeris think things should be? */
//						stcomm.km=FALSE_;/* AU & AU/Day*/
//						stcomm.bary=TRUE_;/*Barycentre (Solar-sys. Barycentre)*/

// **********************
//			step. 2
// **********************
						ntarg =  3;
						pleph(et0,ntarg,nctr,r);
						Eb.max[0]=r[0],Eb.max[1]=r[1],Eb.max[2]=r[2];
						Ed.max[0]=r[3],Ed.max[1]=r[4],Ed.max[2]=r[5];
						Scalar ( Eb, &S_Eb);
						ntarg =  11;
						pleph(et0,ntarg,nctr,r);
						Sb.max[0]=r[0],Sb.max[1]=r[1],Sb.max[2]=r[2];
						Scalar ( Sb, &S_Sb);
						if(Planet==11){
						Sub_Matrix_1(Sb,Eb,&P);
						Scalar ( P, &S_P);
						Eph->d=S_P;
						S_P0=S_P;
						Tau = S_P/173.1446;
						}
						else{
						ntarg =  Planet;
						pleph(et0,ntarg,nctr,r);
						Qb.max[0]=r[0],Qb.max[1]=r[1],Qb.max[2]=r[2];
						Scalar ( Qb, &S_Qb);
						Sub_Matrix_1(Qb,Eb,&P);
						Scalar ( P, &S_P);
						Eph->d=S_P;
						S_P0=S_P;
						Sub_Matrix_1(Eb,Sb,&E);
						Scalar ( E, &S_E);
						Sub_Matrix_1(Qb,Sb,&Q);
						Scalar ( Q, &S_Q);
						Tau = (S_P+2.0*9.87e-9*log(fabs((S_E+S_P+S_Q)/(S_E-S_P+S_Q))))/173.1446;// 2017/08/08 fabs()ǉ
						}
            Eph->Ebx=r[0];    //Barycentric Earth position // 2017/08/15 add
			Eph->Eby=r[1];    //Barycentric Earth position // 2017/08/15 add    
            Eph->Ebz=r[2];    //Barycentric Earth position // 2017/08/15 add    
            Eph->Ebvx=r[3];    //Barycentric Earth speed   // 2017/08/15 add  
            Eph->Ebvy=r[4];    //Barycentric Earth speed   // 2017/08/15 add    
            Eph->Ebvz=r[5];    //Barycentric Earth speed   // 2017/08/15 add     

// ******************

						/* Where does the ephemeris think things should be? */
//						stcomm.km=FALSE_;/* AU & AU/Day*/
//						stcomm.bary=TRUE_;/*Barycentre (Solar-sys. Barycentre)*/
						
						n=0;// 2016/09/12ǉ
						if(Planet==11){

							while(1){	
							et    = et0-Tau;
							nctr  = 12;
						
							ntarg =  11;
							pleph(et,ntarg,nctr,r);
							Sb.max[0]=r[0],Sb.max[1]=r[1],Sb.max[2]=r[2];
							Scalar ( Sb, &S_Sb);

							Sub_Matrix_1(Sb,Eb,&P);
							Scalar ( P, &S_P);
							Tau = S_P/173.1446;
							if(fabs(S_P0-S_P)<1e-9) break;
							S_P0 = S_P;
							if(n>2)printf(" n=%d\n",n); // 2016/09/12ǉ
							n++;// 2016/09/12ǉ
							if(n>10){printf("loop error=1\n");break;}// 2016/09/12ǉ

								}
							}

						else{ 
							while(1){	
							et    = et0-Tau;
							nctr  = 12;
							ntarg =  Planet;
							pleph(et,ntarg,nctr,r);
							Qb.max[0]=r[0],Qb.max[1]=r[1],Qb.max[2]=r[2];
							Scalar ( Qb, &S_Qb);
						
							ntarg =  11;
							pleph(et,ntarg,nctr,r);
							Sb.max[0]=r[0],Sb.max[1]=r[1],Sb.max[2]=r[2];
							Scalar ( Sb, &S_Sb);

							Sub_Matrix_1(Qb,Eb,&P);
							Scalar ( P, &S_P);
							Sub_Matrix_1(Qb,Sb,&Q);
							Scalar ( Q, &S_Q);
							Tau = (S_P+2.0*9.87e-9*log(fabs((S_E+S_P+S_Q)/(S_E-S_P+S_Q))))/173.1446;// 2017/08/08 fabs()ǉ
							if(fabs(S_P0-S_P)<1e-9) break;
							S_P0 = S_P;
							if(n>2)printf(" n=%d\n",n); // 2016/09/12ǉ
							n++;// 2016/09/12ǉ
							if(n>10){printf("loop error=2\n");break;}// 2016/09/12ǉ
							}
						}
            Eph->Sbx=r[0];    //Barycentric Earth position // 2017/08/15 add
			Eph->Sby=r[1];    //Barycentric Earth position // 2017/08/15 add    
            Eph->Sbz=r[2];    //Barycentric Earth position // 2017/08/15 add    

// ********************

			if(Planet==11){
			Multi_Const_Matrix_1(P,1/S_P,&p);
			Scalar ( p, &S_p);}
			else{

			Multi_Const_Matrix_1(P,1/S_P,&p);
			Scalar ( p, &S_p);
			Multi_Const_Matrix_1(Q,1/S_Q,&q);
			Scalar ( q, &S_q);
			Multi_Const_Matrix_1(E,1/S_E,&e);
			Scalar ( e, &S_e);
			}
// **********************
//			step. 3
// ***********************
			if(Planet==11){
				Eql_Matrix_1(p, &p1);
			}
			else{
			Scalar_Dot ( p,q, &S_pq);
			Scalar_Dot ( e,p, &S_ep);
			Scalar_Dot ( q,e, &S_qe);
			Multi_Const_Matrix_1(e,S_pq,&p01);
			Multi_Const_Matrix_1(q,S_ep,&p02);
			Sub_Matrix_1(p01,p02,&p00);
			Multi_Const_Matrix_1(p00,2.0*9.87e-9/S_E/(1+S_qe),&p00);
			Sum_Matrix_1(p,p00,&p1);
			}

// **********************
//			step. 4
// **********************
			Multi_Const_Matrix_1(Ed,0.005775518,&V);//2015/03/15
			Scalar ( V, &S_V);
			Beta=1.0/sqrt(1-S_V*S_V);
			Scalar_Dot ( p1,V, &S_p1V);
			Multi_Const_Matrix_1(p1,1.0/(Beta*(1.0+S_p1V)),&p20);
			Multi_Const_Matrix_1(V,(1.0+S_p1V/(1.0+1.0/Beta))/(1.0+S_p1V),&p21);
			Sum_Matrix_1(p20,p21,&p2);

// **********************
//			step. 5
// **********************
			Obl=OblNu_2000( jd, &dF0, &dE0);// 2017/08/10 mod
			Nutation_Precession_Matrix( jd,&Pr,Obl,dE0,dF0);// 2017/08/10 mod
			Multi_Matrix_1(Pr,p2,&p3);
			Scalar ( p3, &S_p3);

// **********************
//			step. 6
// **********************
			Eph->ra=fmod_rad(atan2(p3.max[1],p3.max[0]));// 2017/08/11 deg->rad
			Eph->dec=asin(p3.max[2]);// 2017/08/11 deg->rad

// **********************
//			step. 7
// **********************
			Matrix_R1(Nu3, Obl , &Nu3);// 2017/08/09 mod
			Multi_Matrix_1(Nu3,p3,&p3);
 			Eph->lam=fmod_rad(atan2(p3.max[1],p3.max[0]));// 2017/08/11 deg->rad
			Eph->bet=asin(p3.max[2]);// 2017/08/11 deg->rad

//ȏœV̂̌ʌvZ͏I

// **********************
//			step. 8 @	z̈ʒuvZ //
// **********************

			// 2017/08/08 xvZ Ephemerides2ɈړBׂ̈̑z̈ʒuvZ͍폜B

			if(Planet <10)
			{
			// **********************
			//			step. 8-1 xvZׂ̈ɑzEnEfԂ̋EpxvZ
			// **********************
			
		Sub_Matrix_1(Sb,Eb,&Eb);// z̒nSW
			sx=Eb.max[0];	sy=Eb.max[1];	sz=Eb.max[2]; srr=sqrt(sx*sx+sy*sy+sz*sz); // z̒nSW 
			px=P.max[0] ;	py=P.max[1] ;	pz=P.max[2] ; dd=sqrt(px*px+py*py+pz*pz);  // f̒nSW
			ex=sx-px;       ey=sy-py;       ez=sz-pz;	  rr=sqrt(ex*ex+ey*ey+ez*ez);  // f̓SW

			pa=fabs(acos((rr*rr+dd*dd-srr*srr)/(2.0*rr*dd)))  ;// 2017/08/11 deg->rad
			Eph->srr=srr; Eph->dd=dd; Eph->rr=rr; Eph->pa=pa;// 2017/08/08 add xvZׂ̈̈p

			}


// **********************
//			step. 10 ǎvZ
// **********************

			switch(Planet){// Astronomical Algorithms 2nd p.389-390ɂ
			case 1	: sd=3.36;break;
			case 2	: sd=8.41;break;
			case 3	: sd=0.0;break;
			case 4	: sd=4.68;break;
			case 5	: sd=92.06;break;// polar ԓ98.44
			case 6	: {sd=82.73;
						// Astronomical Algorithms 2nd p.320ɂyÕp[^߂
						t=T_2000 ( jd);
						inc=(28.075216-0.012998*t+0.000004*t*t)*pai;// 2017/08/11 deg->rad
						omg=(169.508470+1.394681*t+0.000412*t*t)*pai;// 2017/08/11 deg->rad
						B=asin(sin(inc)*cos(Eph->bet)*sin((Eph->lam-omg))-cos(inc)*sin(Eph->bet));// 2017/08/11 deg->rad
						sd=sd*sqrt(1-0.203800*cos(B)*cos(B));// 2017/08/11 deg->rad
						break;
					  }
			case 7	: sd=35.02;break;
			case 8	: sd=33.50;break;
			case 9	: sd=2.07;break;
			case 10	: sd=6378.14;break;
			case 11	: sd=959.63;break;
			default	: sd=0.0;break;
				}

			if(Planet==10)
				{ // Astronomical Algorithms 2nd p.390-391ɂ
				Eph->ss=asin(sd*0.272481/(Eph->d*1.4959787070e8));//1VP=149597870.700km // 2017/08/11 deg->rad
				}
				else
				{Eph->ss=sd/Eph->d/3600.0*pai;} // 2017/08/11 deg->rad

// **********************
//			step. 11 @	tF[Y(zp)̌vZ
// **********************

	if(Planet==11)Eph->ph=0.0;
		else Eph->ph=Eph->lam-Eph->lams;
	Eph->ph=fmod(Eph->ph,pi2);// 2017/08/11 deg->rad

}

/*========================================================================+
|                               Ephemerides2                              |
|                               ␳/AZ&EĽvZ                      |
|                               (2016/09/13)                              |
+=========================================================================*/

void Ephemerides2(FILE *fp_Bin,int DE, double jd,int Planet,Position *Eph,Tlocation Obs)
// jd͐E(UT)
// ϑn̎Oݒ肪Kv
{
	double jd0,pi,lst,H,Hd,a,b,c,qq;//2015/03/15
	double dd,pa,B,t,inc,omg; // 2016/09/12
	double rr,srr,ssx,ssy,ssz,l,spx,spy,spz,sex,sey,sez,u1,u2,ua,ub,dU,N,ld,bd;

// **********************
//			step. 1 @zEf̈ʒuvZ
// **********************
	jd0=jd+DeltaT(T_2000 ( jd))/3600.0/24.0;// DTĐE(UT)͊w(TT:Terrestrial Time )ɕϊB

	// 2017/08/08 add
	Ephemerides( fp_Bin,DE,jd0, 11,Eph);//  z̈ʒuvZjd0͗͊w(TT:Terrestrial Time )
	Eph->ras=Eph->ra;
	Eph->decs=Eph->dec;
	Eph->lams=Eph->lam;
	Eph->bets=Eph->bet;

	Ephemerides( fp_Bin,DE,jd0, Planet,Eph);// f̈ʒuvZ  jd0͗͊w(TT:Terrestrial Time )

// **********************
//			step. 2 @␳̌vZ
// Astronomical Algorithms 2nd p.279-281ɂ
// **********************

	pi=8.794/Eph->d/3600.0*pai;// 2017/08/11 deg->rad
	lst=LST( jd, 0.0);// 2017/08/11 deg->rad
	H=fmod_rad(lst+Obs.lam*pai-Eph->ra);// 2017/08/11 deg->rad

	a = cos(Eph->dec)*sin(H);// 2017/08/11 deg->rad
	b = cos(Eph->dec)*cos(H) - Obs.pcosfd*sin(pi);// 2017/08/11 deg->rad
	c = sin(Eph->dec) - Obs.psinfd*sin(pi);// 2017/08/11 deg->rad
	qq = sqrt(a*a+b*b+c*c);

	Hd = atan2(a,b);// 2017/08/11 deg->rad
	Eph->rap =fmod_rad(lst+Obs.lam*pai-Hd);// 2017/08/11 deg->rad
	Eph->decp=asin(c/qq);// 2017/08/11 deg->rad
	Eph->ssp= Eph->ss/ qq;

	//o܂֕ϊ
	RaToLam(jd, Eph->rap, Eph->decp, &Eph->lamp,&Eph->betp);

// **********************
// 			step. 3 @V̂̍x(Az/El)̌vZ
// **********************

	Az_El(jd,Eph->rap, Eph->decp, Obs.fai, Obs.lam, &Eph->az, &Eph->el );

// **********************
//			step. 4 @	z֌W(x/p)̌vZ
// **********************

	Az_El(jd,Eph->ras, Eph->decs, Obs.fai, Obs.lam, &Eph->azs, &Eph->els );// z̍xʌvZ
	if(Planet==11)Eph->ph=0.0;
	else	Eph->ph=Eph->lamp-Eph->lams;//tF[YizpǰvZ
	Eph->ph=fmod(Eph->ph,pi2);// 2017/08/11 deg->rad

// **********************
//			step. 5 @	fx̌vZ// 2017/08/08 add
// **********************

//		V(1,0)[Ⴆΐ-0.6]́uASTRONOMICAL ALMANACv(2014)ɂB
//		ḿuExplanatory supplement to the ASTRONOMICAL ALMANACv(1992)p.401-407ɂB

if(Planet<10){
			srr=Eph->srr;	rr=Eph->rr;	dd=Eph->dd;	pa=Eph->pa/pai;	// 2017/08/08 add	if(Eph->ph>180.0)Eph->ph=Eph->ph-360.0;// 2017/08/11 deg->rad

			switch(Planet){
				case 1	: Eph->br=-0.60+5.0*log10(rr*dd)+0.0380*pa-0.000273*pa*pa+0.00000200*pa*pa*pa;break;
				case 2	: Eph->br=-4.47+5.0*log10(rr*dd)+0.0009*pa+0.000239*pa*pa-0.00000065*pa*pa*pa;break;
				case 3	: Eph->br=0.0;break;
				case 4	: Eph->br=-1.52+5.0*log10(rr*dd)+0.0160*fabs(pa);break;
				case 5	: Eph->br=-9.40+5.0*log10(rr*dd)+0.0050*fabs(pa);break;
				case 6	: {
						
						// Astronomical Algorithms 2nd p.320ɂyÕp[^߂
						t=T_2000 ( jd);
						inc=(28.075216-0.012998*t+0.000004*t*t)*pai;// 2017/08/11 deg->rad
						omg=(169.508470+1.394681*t+0.000412*t*t)*pai;// 2017/08/11 deg->rad
						B=asin(sin(inc)*cos(Eph->bet)*sin((Eph->lam-omg))-cos(inc)*sin(Eph->bet));// 2017/08/11 deg->rad
		
						l=Eph->lams;// 2017/08/11 deg->rad
						b=Eph->bets;// 2017/08/11 deg->rad
						ssx=srr*cos(b)*cos(l);
						ssy=srr*cos(b)*sin(l);
						ssz=srr*sin(b);
						l=Eph->lam;// 2017/08/11 deg->rad
						b=Eph->bet;// 2017/08/11 deg->rad
						rr=Eph->d;
						sex=rr*cos(b)*cos(l);
						sey=rr*cos(b)*sin(l);
						sez=rr*sin(b);

						spx=sex-ssx;
						spy=sey-ssy;
						spz=sez-ssz;
						rr=sqrt(spx*spx+spy*spy+spz*spz);
						
						// Geometoric heliocentric coordinates
						l=fmod_rad(atan2(spy,spx));// 2017/08/11 deg->rad
						b=atan(spz/sqrt(spx*spx+spy*spy));// 2017/08/11 deg->rad
	
						N=(113.6655+0.8771*t)*pai;// 2017/08/11 deg->rad
						ld=l-0.01759/rr*pai;// 2017/08/11 deg->rad
						bd=b-0.000764*cos((b-N))/rr*pai;// 2017/08/11 deg->rad
						ua=sin(inc)*sin(bd)+cos(inc)*cos(bd)*sin((ld-omg));// 2017/08/11 deg->rad
						ub=cos(bd)*cos((ld-omg));// 2017/08/11 deg->rad
						u1=atan2(ua,ub);// 2017/08/11 deg->rad
						l=Eph->lam;
						b=Eph->bet;
						ua=sin(inc)*sin(b)+cos(inc)*cos(b)*sin((l-omg));// 2017/08/11 deg->rad
						ub=cos(b)*cos((l-omg));// 2017/08/11 deg->rad
						u2=atan2(ua,ub);// 2017/08/11 deg->rad
						dU=fabs(u1-u2)/pai;// 2017/08/11 deg->rad
						Eph->br=-8.88+5.0*log10(rr*dd)+0.0440*dU-2.60*sin(fabs(B))+1.25*sin(fabs(B))*sin(fabs(B));break;// 2017/08/11 deg->rad
					  }
				case 7	: Eph->br=-7.19+5.0*log10(rr*dd)+0.0028*pa;break;
				case 8	: Eph->br=-6.87+5.0*log10(rr*dd);break;
				case 9	: Eph->br=-1.01+5.0*log10(rr*dd)+0.0410*pa;break;
				case 10	: Eph->br=0.0;break;
				case 11	: Eph->br=0.0;break;
				}

		}

}